\ Copyright (c) 2005 Albert van der Horst <albert@spenarnc.xs4all.nl>

\ -------------------- system independant -------------

\ --assembler_i86_fixups_1 [AX] AX| AX|) CF: ?32 \ A4sep27 AvdH

 40 00 4 family|r ZO| BO| XO| R|
 05 fir MEM| \ instead of ZO| BP| )
 01 00 8 family|r [AX] [CX] [DX] [BX] ~SIB| [BP] [SI] [DI]
 01 00 8 family|r AL| CL| DL| BL| AH| CH| DH| BH|
 01 00 8 family|r AX| CX| DX| BX| SP| BP| SI| DI|
 08 00 8 family|r AL'| CL'| DL'| BL'| AH'| CH'| DH'| BH'|
 08 00 8 family|r AX'| CX'| DX'| BX'| SP'| BP'| SI'| DI'|
 08 00 6 family|r ES| CS| SS| DS| FS| GS|
0100 0000 2 family|r B| X|   0200 0000 2 family|r F| T|

\ Use any primed thingies with AS: prefix . )
6 fir MEM|'
1 0 8 family|r [BX+SI]' [BX+DI]' [BP+SI]' [BP+DI]' [SI]' [DI]' [BP]' [BX]'
\ --assembler_i86_fixups_2 SIB,, [AX )   CF: ?32 \ A4sep27 AvdH
\ Fixups from this pages must come after all others
\ and start with a [xx .
  0000 1pi SIB,, \ Required after SIB|

08 00 8 family|r AX] CX] DX] BX] 0] BP] SI] DI]
40 00 4 family|r +1* +2* +4* +8*

 01 00 8 family|r [AX [CX [DX [BX [SP [BP [SI [DI
06 fir [MEM

\ --assembler_commaers ) \ A4sep27 AvdH

\ O=obligatory R=Relative I=Immediate )
' (W,) alias OW,        ' (L,) alias IL,
' (L,) alias (RL,)      ' (W,) alias IW,
' (W,) alias (RW,)      ' (C,) alias IB,
' (C,) alias (RB,)      ' (L,) alias L,
' (W,) alias SG,        ' (W,) alias W,
' (C,) alias P,         ' (C,) alias B,
' (C,) alias IS,


\ --assembler_i86_opcodes_1 )                  \ A4sep27 AvdH
08 06 4 1family, PUSH|ES, PUSH|CS, PUSH|SS, PUSH|DS,
08 07 4 1family, POP|ES, -- POP|SS, POP|DS,
08 26 4 1family, ES:, CS:, SS:, DS:,
08 27 4 1family, DAA, DAS, AAA, AAS,
01 00 2 family|r B'| X'|
08 04 8 1family, ADDI|A, ORI|A, ADCI|A, SBBI|A, ANDI|A, SUBI|A, XORI|A, CMPI|A,
02 A0 2 1family, MOV|TA, MOV|FA,

70 1pi J,  \ As in J, L| Y| <CALC> S, )
    01 00 2 family|r Y| N|
    02 00 8 family|r O| C| Z| CZ| S| P| L| LE|

08 40 4 1family, INC|X, DEC|X, PUSH|X, POP|X,
90 1pi XCHG|AX,
\ --assembler_i86_opcodes_2 )                  \ A4sep27 AvdH
08 00 8 2family, ADD, OR, ADC, SBB, AND, SUB, XOR, CMP,
02 84 2 2family, TEST, XCHG,
01 98 8 1family, CBW, CWD, IR2, WAIT, PUSHF, POPF, SAHF, LAHF,
02 A4 6 1family, MOVS, CMPS, -- STOS, LODS, SCAS,
08 B0 2 1family, MOVI|BR, MOVI|XR,
08 C3 2 1family, RET,  RETFAR,  08 C2 2 1family, RET+, RETFAR+,
01 C4 2 2family, LES, LDS,  00C6 2pi MOVI,   0CD 1pi INT,
01 CC 4 1family, INT3, -- INTO, IRET,
01 D4 4 1family, AAM, AAD, -- XLAT,
01 E0 4 1family, LOOPNZ, LOOPZ, LOOP, JCXZ,
02 E4 2 1family, IN|P, OUT|P,  2 EC 2 1family, IN|D, OUT|D,
01 E8 2 1family, CALL, JMP,

0088 2pi MOV,           008C 2pi MOV|SG,        008D 2pi LEA,
EA 1pi JMPFAR,  EB 1pi JMPS,    9A 1pi CALLFAR, A8 1pi TESTI|A,
\ --assembler_i86_opcodes_3 ) \ A2oct21 AvdH
01 F0 6 1family, LOCK, -- REPNZ, REPZ, HLT, CMC,
01 F8 6 1family, CLC, STC, CLI, STI, CLD, STD, \ 38FE
800 80 8 2family, ADDI, ORI, ADCI, SBBI, ANDI, SUBI, XORI, CMPI,
0800 83 8 2family, ADDSI, -- ADCSI, SBBSI, -- SUBSI, -- CMPSI,
800 10F6 6 2family, NOT, NEG, MUL|AD, IMUL|AD, DIV|AD, IDIV|AD,
0800 00FE 2 2family, INC, DEC,
0800 10FF 4 2family, CALLO, CALLFARO, JMPO, JMPFARO,

0200 0000 2 family|r 1| V|
0800 00D0 8 2family, ROL, ROR, RCL, RCR, SHL, SHR, -- SAR,
0800 C0 8 2family, ROLI, RORI, RCLI, RCRI, SHLI, SHRI, -- SARI,

00F6 2pi TESTI,         008F 2pi POP,           30FF 2pi PUSH,
00AF0F 3pi IMUL,

\ --assembler_i386_opcodes_1 )        CF: ?32    \ A4sep27 AvdH
01 60 2 1family, PUSH|ALL, POP|ALL,
01 62 2 2family, BOUND, ARPL,
01 64 4 1family, FS:, GS:, OS:, AS:,
02 68 2 1family, PUSHI|X, PUSHI|B,
0002 0069 2 2family, IMULI, IMULSI,
02 6C 2 1family, INS, OUTS,
08 00 5 family|r CR0| -- CR2| CR3| CR4|
0008 0100 8 family|r DR0| DR1| DR2| DR3| DR4| DR5| DR6| DR7|

00900F 3pi SET,
100 0 2 family|r Y'| N'|
200 0 8 family|r O'| C'| Z'| CZ'| S'| P'| L'| LE'|

C8 1pi ENTER,           C9 1pi LEAVE,           060F 2pi CLTS,
C0200F 3pi MOV|CD,      800F 2pi J|X,
\ --assembler_i386_opcodes_2 )        CF: ?32    \ A4sep27 AvdH
00,0100 00,020F 2 3family, LAR, LSL,
0100 A00F 3 2family, PUSH|FS, POP|FS, CPUID,
00,0800 00,A30F 4 3family, BT, BTS, BTR, BTC,
00,0100 00,BC0F 2 3family, BSF, BSR,
00,0800 00,A40F 2 3family, SHLDI, SHRDI,
00,0800 00,A50F 2 3family, SHLD|C, SHRD|C,
00,0100 00,B20F 4 3family, LSS, -- LFS, LGS,
00,0800 00,B60F 2 3family, MOVZX|B, MOVSX|B,
00,0800 00,B70F 2 3family, MOVZX|W, MOVSX|W,
0100 A80F 2 2family, PUSH|GS, POP|GS,
08,0000 00,000F 6 3family, SLDT, STR, LLDT, LTR, VERR, VERW,
08,0000 20,BA0F 4 3family, BTI, BTSI, BTRI, BTCI,
08,0000 00,010F 7
    3family, SGDT, SIDT, LGDT, LIDT, SMSW, -- LMSW,
